# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl GSL-CDF.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 67;
BEGIN { use_ok('GSL::CDF') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

use Test::Deep;

cmp_deeply(
    GSL::CDF::gsl_cdf_ugaussian_P(1.000000),
    num(0.841344, 0.000001),
    "gsl_cdf_ugaussian_P(1.0)");

cmp_deeply(
    GSL::CDF::gsl_cdf_ugaussian_Q(1.000000),
    num(0.158655, 0.000001),
    "gsl_cdf_ugaussian_Q(1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_ugaussian_Pinv(0.05),
    num(-1.644853, 0.000001),
    "gsl_cdf_ugaussian_Pinv(0.05)");

cmp_deeply(
    GSL::CDF::gsl_cdf_ugaussian_Qinv(0.05),
    num(1.644853, 0.000001),
    "gsl_cdf_ugaussian_Qinv(0.05)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gaussian_P(0, 1),
    num(0.5, 0.000001),
    "gsl_cdf_gaussian_P(0, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gaussian_Q(0, 1),
    num(0.5, 0.000001),
    "gsl_cdf_gaussian_Q(0, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gaussian_Pinv(0.02, 1),
    num(-2.053748, 0.000001),
    "gsl_cdf_gaussian_Pinv(15, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gaussian_Qinv(0.02, 1),
    num(2.053748, 0.000001),
    "gsl_cdf_gaussian_Qinv(0.02, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gamma_P(1, 2, 3),
    num(0.044624, 0.000001),
    "gsl_cdf_gamma_P(1, 2, 3)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gamma_Q(1, 2, 3),
    num(0.955375, 0.000001),
    "gsl_cdf_gamma_Q(1, 2, 3)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gamma_Pinv(0.1, 2, 0.3),
    num(0.159543, 0.000001),
    "gsl_cdf_gamma_Pinv(0.1, 0.2, 0.3)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gamma_Qinv(0.1, 2, 0.3),
    num(1.166916, 0.000001),
    "gsl_cdf_gamma_Qinv(0.1, 2, 0.3)");

cmp_deeply(
    GSL::CDF::gsl_cdf_cauchy_P(0.1, 2),
    num(0.515902, 0.000001),
    "gsl_cdf_cauchy_P(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_cauchy_Q(0.1, 2),
    num(0.484097, 0.000001),
    "gsl_cdf_cauchy_Q(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_cauchy_Pinv(0.1, 2),
    num(-6.155367, 0.000001),
    "gsl_cdf_cauchy_Pinv(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_cauchy_Qinv(0.1, 2),
    num(6.155367, 0.000001),
    "gsl_cdf_cauchy_Qinv(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_laplace_P(0.1, 2),
    num(0.524385, 0.000001),
    "gsl_cdf_laplace_P(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_laplace_Q(0.1, 2),
    num(0.475614, 0.000001),
    "gsl_cdf_laplace_Q(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_laplace_Pinv(0.1, 2),
    num(-3.218875, 0.000001),
    "gsl_cdf_laplace_P(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_laplace_Qinv(0.1, 2),
    num(3.218875, 0.000001),
    "gsl_cdf_laplace_Q(0.1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_rayleigh_P(0.1, 1),
    num(0.004987, 0.000001),
    "gsl_cdf_rayleigh_P(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_rayleigh_Q(0.1, 1),
    num(0.995012, 0.000001),
    "gsl_cdf_rayleigh_Q(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_rayleigh_Pinv(0.1, 1),
    num(0.459043, 0.000001),
    "gsl_cdf_rayleigh_Pinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_rayleigh_Qinv(0.1, 1),
    num(2.145966, 0.000001),
    "gsl_cdf_rayleigh_Qinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_chisq_P(1.000000, 1),
    num(0.682689, 0.000001),
    "gsl_cdf_chisq_P(1.0, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_chisq_Q(1.000000, 1),
    num(0.317310, 0.000001),
    "gsl_cdf_chisq_Q(1.0, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_chisq_Pinv(0.1, 1),
    num(0.015790, 0.000001),
    "gsl_cdf_chisq_Pinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_chisq_Qinv(0.1, 1),
    num(2.705543, 0.000001),
    "gsl_cdf_chisq_Qinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_exponential_P(0.1, 1),
    num(0.095162, 0.000001),
    "gsl_cdf_exponential_P(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_exponential_Q(0.1, 1),
    num(0.904837, 0.000001),
    "gsl_cdf_exponential_Q(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_exponential_Pinv(0.1, 1),
    num(0.105360, 0.000001),
    "gsl_cdf_exponential_Pinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_exponential_Qinv(0.1, 1),
    num(2.302585, 0.000001),
    "gsl_cdf_exponential_Qinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_exppow_P(0.1, 1, 2),
    num(0.556231, 0.000001),
    "gsl_cdf_exppow_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_exppow_Q(0.1, 1, 2),
    num(0.443768, 0.000001),
    "gsl_cdf_exponentialpow_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_tdist_P(0.1, 1),
    num(0.531725, 0.000001),
    "gsl_cdf_tdist_P(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_tdist_Q(0.1, 1),
    num(0.468274, 0.000001),
    "gsl_cdf_tdist_Q(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_tdist_Pinv(0.1, 1),
    num(-3.077683, 0.000001),
    "gsl_cdf_tdist_Pinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_tdist_Qinv(0.1, 1),
    num(3.077683, 0.000001),
    "gsl_cdf_tdist_Qinv(0.1, 1)");

cmp_deeply(
    GSL::CDF::gsl_cdf_fdist_P(0.1, 1, 2),
    num(0.218217, 0.000001),
    "gsl_cdf_fdist_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_fdist_Q(0.1, 1, 2),
    num(0.781782, 0.000001),
    "gsl_cdf_fdist_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_fdist_Pinv(0.1, 1, 2),
    num(0.020202, 0.000001),
    "gsl_cdf_fdist_Pinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_fdist_Qinv(0.1, 1, 2),
    num(8.526315, 0.000001),
    "gsl_cdf_fdist_Qinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_beta_P(0.1, 1, 2),
    num(0.19, 0.000001),
    "gsl_cdf_beta_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_beta_Q(0.1, 1, 2),
    num(0.81, 0.000001),
    "gsl_cdf_beta_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_beta_Pinv(0.1, 1, 2),
    num(0.051316, 0.000001),
    "gsl_cdf_beta_Pinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_beta_Qinv(0.1, 1, 2),
    num(0.683772, 0.000001),
    "gsl_cdf_beta_Qinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_flat_P(0.1, 0.01, 2),
    num(0.045226, 0.000001),
    "gsl_cdf_flat_P(0.1, 0.01, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_flat_Q(0.1, 0.01, 2),
    num(0.954773, 0.000001),
    "gsl_cdf_flat_Q(0.1, 0.01, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_flat_Pinv(0.1, 0.01, 2),
    num(0.209, 0.000001),
    "gsl_cdf_flat_Pinv(0.1, 0.01, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_flat_Qinv(0.1, 0.01, 2),
    num(1.801, 0.000001),
    "gsl_cdf_flat_Qinv(0.1, 0.01, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_lognormal_P(0.1, 1, 2),
    num(0.049339, 0.000001),
    "gsl_cdf_lognormal_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_lognormal_Q(0.1, 1, 2),
    num(0.950660, 0.000001),
    "gsl_cdf_lognormal_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_lognormal_Pinv(0.1, 1, 2),
    num(0.209485, 0.000001),
    "gsl_cdf_lognormal_Pinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_lognormal_Qinv(0.1, 1, 2),
    num(35.272482, 0.000001),
    "gsl_cdf_lognormal_Qinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel1_P(0.1, 1, 2),
    num(0.163707, 0.000001),
    "gsl_cdf_gumbel1_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel1_Q(0.1, 1, 2),
    num(0.836292, 0.000001),
    "gsl_cdf_gumbel1_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel1_Pinv(0.1, 1, 2),
    num(-0.140885, 0.000001),
    "gsl_cdf_gumbel1_Pinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel1_Qinv(0.1, 1, 2),
    num(2.943514, 0.000001),
    "gsl_cdf_gumbel1_Qinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel2_P(0.1, 1, 2),
    num(2.061153e-09, 1e-15),
    "gsl_cdf_gumbel2_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel2_Q(0.1, 1, 2),
    num(0.999999, 0.000001),
    "gsl_cdf_gumbel2_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel2_Pinv(0.1, 1, 2),
    num(0.868588, 0.000001),
    "gsl_cdf_gumbel2_Pinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_gumbel2_Qinv(0.1, 1, 2),
    num(18.982443, 0.000001),
    "gsl_cdf_gumbel2_Qinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_weibull_P(0.1, 1, 2),
    num(0.009950, 0.000001),
    "gsl_cdf_weibull_P(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_weibull_Q(0.1, 1, 2),
    num(0.990049, 0.000001),
    "gsl_cdf_weibull_Q(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_weibull_Pinv(0.1, 1, 2),
    num(0.324592, 0.000001),
    "gsl_cdf_weibull_Pinv(0.1, 1, 2)");

cmp_deeply(
    GSL::CDF::gsl_cdf_weibull_Qinv(0.1, 1, 2),
    num(1.517427, 0.000001),
    "gsl_cdf_weibull_Qinv(0.1, 1, 2)");
